﻿#include <bits/stdc++.h>

#ifdef dvb1r
#include "algo_debug.h"
#include "Timer.h"
// #else
//     #define debug(...)
#endif

using namespace std;
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <utility>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = int64_t;
using ull = uint64_t;

template<typename a, typename b>
istream &operator>>(istream &in, pair<a, b> &p) {
    in >> p.first;
    in >> p.second;
    return in;
}

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) in >> x;
    return in;
}

template<bool need = 1, typename a, typename b>
ostream &operator<<(ostream &out, pair<a, b> &p) {
    out << p.first << (need ? " " : "") << p.second;
    return out;
}

template<bool need = 1, typename t>
ostream &operator<<(ostream &out, vector<t> &a) {
    for (auto &x : a) out << x << (need ? " " : "");
    return out;
}

const int mod = 1e9 + 7;
// const long double pi = atan2(0, -1);
ll oo = 1e18;
using ld = long double;

template<typename T>
T remin(T &a, T b) { return a = min(a, b); }

template<typename T>
T remax(T &a, T b) { return a = max(a, b); }

// #define int int64_t

struct drob {
    int x, y;
    drob operator+(const drob& o) const  {
        drob rs{};
        rs.x = x + o.x;
        rs.y = y + o.y;
        return rs;
    }
    bool operator==(const drob& o) const {
        return x == o.x && y == o.y;
    }
    bool operator<(const drob& o) const {
        return x * 1ll * o.y < y * 1ll * o.x;
    }
    bool operator>(const drob& o) const {
        return x * 1ll * o.y > y * 1ll * o.x;
    }
};

ostream& operator<<(ostream& out, const drob& o) {
    out << o.x << '/' << o.y;
    return out;
}

void solve() {
    int n, m, k; cin >> n >> m >> k;
    vector<vector<int>> g(n);
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> achievable(n, 0);
    vector<pair<int, int>> guardians(k); cin >> guardians;
    for(auto& p : guardians) p.first--;
    for(auto& [i, d] : guardians) {
        queue<int> q;
        vector<int> dist(n, 10 * n);
        q.push(i);
        dist[i] = 0;
        while(!q.empty()) {
            int x = q.front();
            q.pop();
            achievable[x] = 1;
            if(dist[x] >= d) continue;
            for(auto& v : g[x]) {
                if(dist[v] > dist[x] + 1) {
                    q.push(v);
                    dist[v] = dist[x] + 1;
                }
            }
        }
    }
    int cnt = accumulate(achievable.begin(), achievable.end(), 0);
    cout << cnt << '\n';
    for(int i = 0; i < n; ++i) if(achievable[i]) cout << i + 1 << ' ';
}

int32_t main() {
#ifdef dvb1r
    Timer timer;
    timer.start();
#endif

#ifdef dvb1r
    // freopen("input.txt", "r", stdin);
#endif
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
#ifdef dvb1r
    timer.finish();
    cerr << "\nruntime: " << timer() << "ms\n";
#endif
    return 0;
}
